#include<bits/stdc++.h>

using namespace std;

struct par {
	int l, r;
};


signed main() {
	
	ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
	
	int n; cin >> n;
	vector<int> numb(n);
	for(int i = 0; i < n; i++) {
		cin >> numb[i];
	}
	
	vector<par> t;
	
	for(int i = 0; i < n+2; i++) {
		for(int j = 1; j < n; j++) {
			if(numb[j] < numb[j-1]) {
				t.push_back({j, j+1});
				
				numb[j-1] = numb[j] ^ numb[j-1];
				numb[j] = numb[j] ^ numb[j-1];
				numb[j-1] = numb[j] ^ numb[j-1];
			}
		}
	}

	cout << t.size() << endl;
	for(int i = 0; i < t.size(); i++) {
		cout << t[i].l << " " << t[i].r << endl;
	}
	
	return 0;
}